      subroutine bigrid(depth)
c
c --- this version cyclic in j
c
c --- set loop bounds for irregular basin in c-grid configuration
c --- q,u,v,p are vorticity, u-velocity, v-velocity, and mass points, resp.
c --- 'depth' = basin depth array, zero values indicate land
c
      include 'dimensions.h'
c
      common/linepr/lp
c
      dimension depth(idm,jdm)
c
      do 17 i=1,ii
      do 17 j=1,jj
      ip(i,j)=0
      iq(i,j)=0
      iu(i,j)=0
 17   iv(i,j)=0
c
c --- fill single-width inlets
 16   nfill=0
      do 15 j=1,jj
      ja=mod(j-2+jj,jj)+1
      jb=mod(j     ,jj)+1
      do 15 i=1,ii1
      nzero=0
      if (depth(i,j).gt.0.) then
      if (i.eq.1  .or.depth(i-1,j).le.0.) nzero=nzero+1
      if (i.eq.ii1.or.depth(i+1,j).le.0.) nzero=nzero+1
      if (depth(i,ja).le.0.) nzero=nzero+1
      if (depth(i,jb).le.0.) nzero=nzero+1
      if (nzero.ge.3) then
      write (lp,'('' depth('',i3,'','',i3,'') set to zero'')') i,j
      depth(i,j)=0.
      nfill=nfill+1
      end if
      end if
 15   continue
      if (nfill.gt.0) go to 16
c
c --- mass points are defined where water depth is greater than zero
      do 2 j=1,jj
      do 2 i=1,ii1
      if (depth(i,j).gt.0.) ip(i,j)=1
  2   continue
c
c --- u,v points are located halfway between any 2 adjoining mass points
      do 4 j=1,jj
      ja=mod(j-2+jj,jj)+1
      do 3 i=2,ii1
      if (ip(i-1,j).gt.0.and.ip(i,j).gt.0) iu(i,j)=1
  3   continue
      do 4 i=1,ii1
      if (ip(i,ja ).gt.0.and.ip(i,j).gt.0) iv(i,j)=1
  4   continue
c
c --- 'interior' q points require water on all 4 sides.
      do 5 j=1,jj
      ja=mod(j-2+jj,jj)+1
      do 5 i=2,ii1
      if (min(ip(i,j),ip(i-1,j),ip(i,ja ),ip(i-1,ja )).gt.0) iq(i,j)=1
  5   continue
c
c --- 'promontory' q points require water on 3 (or at least 2 diametrically 
c --- opposed) sides
      do 10 j=1,jj
      ja=mod(j-2+jj,jj)+1
      do 10 i=2,ii1
      if ((ip(i  ,j).gt.0.and.ip(i-1,ja ).gt.0).or.
     .    (ip(i-1,j).gt.0.and.ip(i  ,ja ).gt.0)) iq(i,j)=1
 10   continue
c
c --- determine loop bounds for vorticity points, including interior and
c --- promontory points
      call indxi(iq,ifq,ilq,isq)
      call indxj(iq,jfq,jlq,jsq)
c
c --- determine loop indices for mass and velocity points
      call indxi(ip,ifp,ilp,isp)
      call indxj(ip,jfp,jlp,jsp)
      call indxi(iu,ifu,ilu,isu)
      call indxj(iu,jfu,jlu,jsu)
      call indxi(iv,ifv,ilv,isv)
      call indxj(iv,jfv,jlv,jsv)
c
      return
      end
