      block data blkdat
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
c --- specific volume in layer k is  alpha = 1/rho = thref x ( 1 - theta(k) )
c      data theta/.027,.02723,.02757,.0277/
c      data theta/.027,.0277,.0284/
      data theta/.027,.02735,.0277/
c      data dp0/1000.,0.,0.,3000./   
      data dp0/750.,500.,2750./
      data thbase/.025/
      data scale/2.e5/
      data vbar0/-1./
c      data vbar0/0./
c
c --- 'baclin' = baroclinic time step
c --- 'batrop' = barotropic time step
c --- 'diagfq' = number of days between model diagnostics (incl.output)
c      data baclin,batrop/400.,10./,diagfq/5./
      data baclin,batrop/180.,5./,diagfq/5./
c
c --- 'thkdff' = diffusion velocity (cm/s) for thickness diffusion
c --- 'veldff' = diffusion velocity (cm/s) for momentum dissipation
c --- 'temdff' = diffusion velocity (cm/s) for temp/salin. mixing
c --- 'viscos' is nondimensional, used in deformation-dependent viscosity
      data thkdff/0./,veldff/1./,temdff/0./,viscos/0./
c
c --- 'diapyc' = diapycnal diffusivity times buoyancy freq. (cm**2/s**2)
c --- 'vertmx' = diffusion velocity (cm/s) for mom.mixing across mix.layr.base
c --- 'mixfrq' = number of time steps between diapycnal mixing calculations
c --- 'h0'     = vertical averaging depth for diapycnic flux calculations
c --- 'h1'     = depth interval used in lateral weighting of hor.pres.grad.
c --- 'thkmin' = minimum mixed-layer thickness (m)
      data diapyc/0./,vertmx/2.e-3/,mixfrq/480/
      data h0/980600./,h1/980600./,thkmin/20./
c
c --- slip=+1  for free-slip boundary cond., slip=-1  for non-slip cond.
c --- 'cbar'   = rms flow speed (cm/s) for linear bottom friction law
c --- 'thkbot' = thickness of bottom boundary layer (pressure units)
      data slip/1./,cbar/0./,thkbot/980600./
c
c --- weights for time smoothing
ccc      data wuv1,wuv2/.5,.25/
      data wuv1,wuv2/.75,.125/
ccc      data wts1,wts2/.875,.0625/
ccc      data wts1,wts2/.9375,.03125/
      data wts1,wts2/.96875,.015625/
      data wbaro/.125/
c
c --- layer thicknesses in units of pressure:
      data tenm,onem,tencm,onecm,onemm/980600.,98060.,9806.,980.6,98.06/
      data radian/57.2957795/,pi/3.1415926536/
c
c --- 'g'      = gravitational acceleration
c --- 'csubp'  = specific heat of air at constant pressure (j/g/deg)
c --- 'spcifh' = specific heat of sea water (j/g/deg)
c --- 'cd'     = drag coefficient
c --- 'ct'     = thermal transfer coefficient
c --- 'airdns' = air density at sea level (g/cm**3)
c --- 'evaplh' = latent heat of evaporation (j/g)
c --- 'thref'  = reference value of specific volume (cm**3/g)
c --- 'epsil'  = small nonzero number used to prevent division by zero
      data g/980.6/,csubp/1.0057/,spcifh/3.99/,cd/.0013/,ct/.0012/
      data airdns/1.2e-3/,evaplh/2.47e3/,thref/1./,epsil/1.e-11/
c
c --- 'itest,jtest' = grid point where detailed diagnostics are desired
      data itest,jtest/30,75/
c
c --- the location of the grid on the mercator map is specified in terms of
c ---      gridn         --  grid size in degrees longitude,
c ---      xpivn         --  the i index of the equator
c
      data xpivn,gridn/596.,.1/
c
      data thermo/.false./,relax/.false./
c
c      
      end
