      subroutine getdpth
c
c --- generate basin depths
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
c --- function allowing cyclic shift in j direction:
ccc      jcyc(j)=mod(j,jj)+1
      jcyc(j)=j
c
      do 10 j=1,jj
      do 10 i=1,ii1
      util1(i,j)=0.
 10   util2(i,j)=0.
c
      imtn=ii1/2
      jmtn=jj
      util2(imtn,jmtn)=1.
c
      do 11 iter=1,15
c
      do 12 i=2,ii1-1
      do 12 j=1,jj
 12   util1(i,j)=.5*util2(i,j)+.25*(util2(i-1,j)+util2(i+1,j))
c
      do 13 j=1,jj
      ja=mod(j-2+jj,jj)+1
      jb=mod(j     ,jj)+1
      do 13 i=1,ii1
 13   util2(i,j)=.5*util1(i,j)+.25*(util1(i,ja )+util1(i,jb ))
 11   continue
c
      factor=1./util2(imtn,jmtn)
      do 14 j=1,jj
      do 14 i=1,ii1
 14   util2(i,j)=util2(i,j)*factor
c
c     cylinder
c
      rmax=50.e5
      do 6 j=1,jj
      do 6 i=1,ii
        depths(i,j)=4000.
        ss=(i-ii1/2)**2+(j-50.)**2
        ra=sqrt(ss)*scale
        if(ra.le.rmax) depths(i,j)=100.
 6      continue
c       one grid point seamount
c        depths(ii1/2,55)=500.
c
c     gaussian
c
c        rmax=25.e5
c      do 6 j=1,jj
c      do 6 i=1,ii
c        depths(i,j)=4000.
c        ss=(i-ii1/2)**2+(j-jj/2)**2
c        ra=sqrt(ss)*scale
c        if(ra.le.rmax) 
c     .   depths(i,j)=4000.
c     .    -3500.*exp(-1.*ra**2/(2*rmax**2))
c 6      continue
c
c --- determine do-loop limits for u,v,p,q points
      call bigrid(depths)
c      do 3 i=1,ii
c      write (*,'('' i='',i3,'' jfp,jlp='',7(1x,2i4))') i,
c     . (jfp(i,l),jlp(i,l),l=1,jsp(i))
c      write (*,'('' i='',i3,'' jfu,jlu='',7(1x,2i4))') i,
c     . (jfu(i,l),jlu(i,l),l=1,jsu(i))
c      write (*,'('' i='',i3,'' jfv,jlv='',7(1x,2i4))') i,
c     . (jfv(i,l),jlv(i,l),l=1,jsv(i))
c      write (*,'('' i='',i3,'' jfq,jlq='',7(1x,2i4))') i,
c     . (jfq(i,l),jlq(i,l),l=1,jsq(i))
c 3    continue
c      do 5 j=1,jj
c      write (*,'('' j='',i3,'' ifp,ilp='',7(1x,2i4))') j,
c     . (ifp(j,l),ilp(j,l),l=1,isp(j))
c      write (*,'('' j='',i3,'' ifu,ilu='',7(1x,2i4))') j,
c     . (ifu(j,l),ilu(j,l),l=1,isu(j))
c      write (*,'('' j='',i3,'' ifv,ilv='',7(1x,2i4))') j,
c     . (ifv(j,l),ilv(j,l),l=1,isv(j))
c      write (*,'('' j='',i3,'' ifq,ilq='',7(1x,2i4))') j,
c     . (ifq(j,l),ilq(j,l),l=1,isq(j))
c 5    continue
c
c      call prtmsk(ip,depths,util1,idm,ii1,jj,0.,1.,
c     .     'bottom depth (m)        ')
c
      return
      end
