      program micom
c
c --- --------------------------------------
c --- miami isopycnic coordinate ocean model
c
c ---         v e r s i o n    2.6
c
c --- channel geometry with cyclic boundary
c ---     conditions in j (y) direction
c --- --------------------------------------
c
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common/linepr/lp
c
      real realat,sum,coord,day1,day2,x,x1,time0
      integer lp,nstep0,ni,no,nop,ii2,idim,jdim,length
      character*2 util(idm*jdm+14),preambl(5)*79
      data nstep0,time0/0,0./
c
      include 'stmt_functions.h'
c
      lp=6
      write (lp,'('' turb. flux parameters:'',1p/
     .  '' thkdff,temdff,veldff ='',3e9.2/
     .  '' viscos,diapyc,vertmx ='',3e9.2)')
     .     thkdff,temdff,veldff,viscos,diapyc,vertmx
c
c --- 'lstep' = number of barotropic time steps per baroclinic time step.
c --- lstep   m u s t   be even.
c
      lstep=baclin/batrop
      lstep=2*((lstep+1)/2)
      dlt=baclin/lstep
      write (lp,'(i4,'' barotropic steps per baroclinic time step'')')
     .  lstep
c
c --- get channel depth array
      call getdpth
c
c --- define coriolis parameter and grid size
      do 56  i=1,ii
      realat=alat(xpivn-float(i)+.5,gridn)
c      corio(i,1)=.9e-4-float(i-ii1/2)*scale*2.e-13
      corio(i,1)=1.e-4
      do 561 j=2,jj
 561  corio(i,j)=corio(i,1)
c --- scu,scv,scp: grid scale at  u,v,p  points respectively
      scu(i)=scale
      scv(i)=scale
      scp(i)=scv(i)
      scu2(i)=scu(i)**2
      scv2(i)=scv(i)**2
      scp2(i)=scp(i)**2
c
      scui(i)=1./scu(i)
      scvi(i)=1./scv(i)
      scpi(i)=1./scp(i)
      scu2i(i)=1./scu2(i)
      scv2i(i)=1./scv2(i)
      scp2i(i)=1./scp2(i)
 56   continue
cdiag write (lp,'('' mesh size, u points:''1p/(1x,8e9.2))') scu
cdiag write (lp,'('' mesh size, v points:''1p/(1x,8e9.2))') scv
cdiag call zebra(corio,idm,ii,jj)
cdiag write (lp,'('' shown above: coriolis parameter'')')
c
      area=0.
c
      do 57 j=1,jj
      do 57 l=1,isp(j)
      do 57 i=ifp(j,l),ilp(j,l)
 57   area=area+scp2(i)
c
c --- set up  f o r c i n g  functions (one per month for each variable)
c
      call forfun
      watcum=0.
      empcum=0.
c
      call inicon
c
c
c --- model is to be integrated from time step 'nstep1' to 'nstep2'
      nstep1=0.*86400./baclin + .0001
      day2=200.
      nstep2=day2*86400./baclin + .0001
c      nstep2=10
c
      delt1=baclin
      if (nstep1.le.0) go to 2
      delt1=baclin+baclin
c
c --- start from restart file
c
      ni=11
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c --- option 1: read genuine binary restart file
c
      read (ni) nstep0,time0,u
      read (ni) nstep0,time0,v
      read (ni) nstep0,time0,dp
      read (ni) nstep0,time0,temp
      read (ni) nstep0,time0,saln
      read (ni) nstep0,time0,thmix,ubavg,vbavg,pbavg
      if (trcrin)
     .read (ni) nstep0,time0,tracer
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c --- option 2: concoct restart file from ascii archive file
c
ccc      open (unit=ni,file='archive.dy1800',status='old',readonly)
ccc      call restart(ni,day1)
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c --- diagnose pressure at p,u,v points from restart -dp- field
c
      do 16 m=1,2
      mm=(m-1)*kk
c
      do 18 j=1,jj
      do 18 k=1,kk
      do 18 l=1,isp(j)
      do 18 i=ifp(j,l),ilp(j,l)
 18   p(i,j,k+1)=p(i,j,k)+dp(i,j,k+mm)
c
      call dpudpv(p,depthu,depthv,dpu(1,1,1+mm),dpv(1,1,1+mm))
 16   continue
c
      nstep0=time0*86400./baclin+.0001
      write (lp,111) nstep0,nstep1
 111  format (9x,'time step in restart file -',i9,5x,'wanted -',i9)
      if (nstep0.eq.nstep1) go to 2
c
c --- if restart file allows restart at a time greater than nstep1, use it
      nstep2=nstep0+nstep2-nstep1
      nstep1=nstep0
c
 2    nstep=nstep1
      write (lp,102) nstep
 102  format (/' model integration starts from time step',i9)
c
c --- ---------------------
c --- main loop starts here
c --- ---------------------
c
c --- letter 'm' refers to mid-time level (example: dp(i,j,km) )
c --- letter 'n' refers to old and new time level
c
 15   m=mod(nstep  ,2)+1
      n=mod(nstep+1,2)+1
      mm=(m-1)*kk
      nn=(n-1)*kk
      k1m=1+mm
      k1n=1+nn
c
      nstep=nstep+1
      time=time0+(nstep-nstep0)*baclin/86400.
      diagno=.false.
      if (amod(time+.0001,diagfq).lt..0002) diagno=.true.
      if (nstep.eq.1.or.nstep.ge.nstep2) diagno=.true.
cdiag diagno=.true.
c
c --- set weights for quasi-hermite time interpolation among monthly forcing
c --- fields
      x=1.+amod(time,360.)/30.
      l1=x
      l0=mod(l1+10,12)+1
      l2=mod(l1,12)+1
      l3=mod(l2,12)+1
      x=x-float(l1)
      x1=1.-x
      w1=x1*(1.+x *(1.-1.5*x ))
      w2=x *(1.+x1*(1.-1.5*x1))
      w0=-.5*x *x1*x1
      w3=-.5*x1*x *x
cdiag write (lp,'(i9,'' time interpolation: months'',4i3,'',  weights '',
cdiag.  4f6.3)') nstep,l0,l1,l2,l3,w0,w1,w2,w3
c
c --- set weights for quasi-hermite time interpolation among seasonal (4/year)
c --- forcing fields
      x=1.+amod(time+330.,360.)/90.
      ls1=x
      ls0=mod(ls1+2,4)+1
      ls2=mod(ls1  ,4)+1
      ls3=mod(ls2,  4)+1
      x=x-float(ls1)
      x1=1.-x
      ws1=x1*(1.+x *(1.-1.5*x ))
      ws2=x *(1.+x1*(1.-1.5*x1))
      ws0=-.5*x *x1*x1
      ws3=-.5*x1*x *x
cdiag write (lp,'(i9,'' time interpolation: seasons'',4i3,
cdiag.'',  weights '',4f7.3)') nstep,ls0,ls1,ls2,ls3,ws0,ws1,ws2,ws3
c
      call cnuity(m,n,mm,nn,k1m,k1n)
c      call tsadvc(m,n,mm,nn,k1m,k1n)
      call momeq1(m,n,mm,nn,k1m,k1n)
      call momeq2(m,n,mm,nn,k1m,k1n)
      call barotp(m,n,mm,nn,k1m,k1n)
c      call convec(m,n,mm,nn,k1m,k1n)
c      call diapfl(m,n,mm,nn,k1m,k1n)
c      if (thermo)
c     .call thermf(m,n,mm,nn,k1m,k1n)
c      call mxlayr(m,n,mm,nn,k1m,k1n)
c
c ---------------------------------------------------------------------------
c
c --- output and diagnostic calculations
c
c ---------------------------------------------------------------------------
c
      if (diagno .or. mod(nstep,mixfrq).eq.0) then
        sum=0.
        do 704 j=1,jj
        do 704 l=1,isp(j)
        do 704 i=ifp(j,l),ilp(j,l)
 704    sum=sum+(montg(i,j,1)+thref*pbavg(i,j,m))*scp2(i)
        write (lp,'(i9,'' mean sea srf.hgt. (mm):'',f9.2)') nstep,
     .  sum/(area*onemm)
c
C
C --- ENERGY DIAGNOSTICS
C
      PBAR=0.
      SUMWGT=0.
      SUMPOT=0.
      SUMKIN=0.
      SUMXGR=0.
      SUMSTR=0.
      SUMDIS=0.
      SUMEKT=0.
      DO 53 K=1,KK
      KM=K+MM
      EPOT=0.
      EKIN=0.
      WEIGHT=0.
      DO 51 J=1,JJ
      JA=MOD(J-2+JJ,JJ)+1
      JB=MOD(J     ,JJ)+1
      DO 51 I=1,II1
        IF (K.EQ.1) EPOT=0.
      IF (K.GT.1)
     &EPOT=EPOT+.5*(P(I,J,K)-PBAR)**2*(THETA(K)-THETA(K-1))/G
      EKIN=EKIN+.25*DP(I,J,KM)*((U(I,J,KM)+ubavg(i,j,m))**2
     &  +(U(I+1,J,KM)+ubavg(i+1,j,m))**2
     &  +(V(I,J,KM)+vbavg(i,j,m))**2
     &  +(V(I,JB ,KM)+vbavg(i,jb,m))**2)/G
51    WEIGHT=WEIGHT+DP(I,J,KM)-DP0(K)
      EPOT=EPOT/(II1*JJ)
      EKIN=EKIN/(II1*JJ)
      WEIGHT=WEIGHT/(II1*JJ)
      PRINT 101,WEIGHT,EPOT,EKIN,EKINT,SUMXGR,SUMSTR,SUMDIS,K
101   FORMAT (' MASS'1PE10.2'  EPOT'E10.2'  EKIN'E10.2'  EKINT'E10.2
     .'  XCONT'E10.2'  STRESS'E10.2'  DISSIP'E10.2,I4)
      SUMWGT=SUMWGT+WEIGHT
      SUMKIN=SUMKIN+EKIN
      SUMPOT=SUMPOT+EPOT
      SUMXGR=SUMXGR
      SUMSTR=SUMSTR
      SUMDIS=SUMDIS
      SUMEKT=SUMEKT
      DO 53 J=1,JJ
      DO 53 I=1,II1
53    PBAR=PBAR+DP(I,J,KM)/(II1*JJ)
      PRINT 101,SUMWGT,SUMPOT,SUMKIN,SUMEKT,SUMXGR,SUMSTR,SUMDIS
      end if
c
c --- diagnose meridional overturning and heat flux
ccc      if (mod(time+.0001,15.).lt..0002) call overtn
ccc      if (nstep.ge.nstep2.and.time.lt.15.) call overtn
c
      if (.not.diagno) go to 23
c
      write (lp,100) nstep,int((time+.001)/360.),amod(time+.001,360.)
 100  format (' time step',i9,9x,'y e a r',i6,9x,'d a y',f9.2)
c
c --- output to history file
c
      write(10)(((u(i,j,k+nn)+ubavg(i,j,n),v(i,j,k+nn)+vbavg(i,j,n)
     &  ,dp(i,j,k+nn),i=1,ii),j=1,jj),k=1,kk),nstep
c
c --- output to restart file
c
      no=12
      rewind no
      write (no) nstep,time,u
      write (no) nstep,time,v
      write (no) nstep,time,dp
      write (no) nstep,time,temp
      write (no) nstep,time,saln
      write (no) nstep,time,thmix,ubavg,vbavg,pbavg
      if (trcout)
     .write (no) nstep,time,tracer
c
      write (lp,105) nstep
 105  format (' step',i9,' -- archiving completed --')
c
c
 23   if (nstep.ge.nstep2) stop '(normal)'
      delt1=baclin+baclin
      go to 15
      end
