      subroutine momeq1(m,n,mm,nn,k1m,k1n)
c
c --- version 2.6 -- cyclic in j
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      real phi,plo,ubot,vbot,th2,stresx,stresy
c
c --- --------------------
c --- hydrostatic equation
c --- --------------------
c
      do 13 j=1,jj
      do 13 l=1,isp(j)
c
      do 8 k=1,kk
      do 8 i=ifp(j,l),ilp(j,l)
 8    p(i,j,k+1)=p(i,j,k)+dp(i,j,k+mm)
c
      do 80 i=ifp(j,l),ilp(j,l)
      util1(i,j)=1.+pbavg(i,j,m)/p(i,j,kk+1)
 80   montg(i,j,kk)=psikk(i,j)-pbavg(i,j,m)*(theta(kk)+thbase)*thref
c
      do 81 k=kk-1,2,-1
      do 81 i=ifp(j,l),ilp(j,l)
 81   montg(i,j,k)=montg(i,j,k+1)
     .             +p(i,j,k+1)*(theta(k+1)-theta(k))*thref*util1(i,j)
c
      do 13 i=ifp(j,l),ilp(j,l)
 13   montg(i,j,1)=montg(i,j,2)
     .             +p(i,j,2)*(theta(2)-thmix(i,j,m))*thref*util1(i,j)
c
      call dpudpv(p,depthu,depthv,dpu(1,1,1+mm),dpv(1,1,1+mm))
c
c +++ ++++++++++++++++++
c +++ momentum equations
c +++ ++++++++++++++++++
c
c --- bottom drag (standard bulk formula)
c
      do 804 j=1,jj
      jb=mod(j     ,jj)+1
      do 804 l=1,isp(j)
c
      do 800 i=ifp(j,l),ilp(j,l)
      util1(i,j)=0.
 800  util2(i,j)=0.
c
      do 801 k=1,kk
      kn=k+nn
      do 801 i=ifp(j,l),ilp(j,l)
      phi=max(p(i,j,k+1),p(i,j,kk+1)-thkbot)
      plo=max(p(i,j,k  ),p(i,j,kk+1)-thkbot)
      util1(i,j)=util1(i,j)+(u(i,j,kn)+u(i+1,j,kn))*(phi-plo)
 801  util2(i,j)=util2(i,j)+(v(i,j,kn)+v(i,jb ,kn))*(phi-plo)
c
      do 804 i=ifp(j,l),ilp(j,l)
      ubot=ubavg(i,j,n)+ubavg(i+1,j,n)+util1(i,j)/thkbot
      vbot=vbavg(i,j,n)+vbavg(i,jb ,n)+util2(i,j)/thkbot
 804  drag(i,j)=0.
c 804  drag(i,j)=.003*(.25*sqrt(ubot*ubot+vbot*vbot)+cbar)
c     .          *g/(thref*thkbot)
c
c --- store r.h.s. of barotropic u/v eqn. in -ubrhs,vbrhs-
c --- store layer 1 pressure gradient plus wind forcing in -gradx,grady-
c --- press.gradient is written in the form  alpha * grad p  +  grad phi
c
      th2=thref*(1.-thbase-theta(2))
c
      do 70 j=1,jj
      ja=mod(j-2+jj,jj)+1
      jb=mod(j     ,jj)+1
c
      do 69 l=1,isu(j)
      do 69 i=ifu(j,l),ilu(j,l)
      ubrhs(i,j)=
     . (vbavg(i  ,j,m)*depthv(i  ,j)+vbavg(i  ,jb ,m)*depthv(i  ,jb )
     . +vbavg(i-1,j,m)*depthv(i-1,j)+vbavg(i-1,jb ,m)*depthv(i-1,jb ))
     . *(pvtrop(i,j)+pvtrop(i,jb ))*.125
c
      stresx=((taux(i,j,l0)+taux(i-1,j,l0))*w0
     .       +(taux(i,j,l1)+taux(i-1,j,l1))*w1
     .       +(taux(i,j,l2)+taux(i-1,j,l2))*w2
     .       +(taux(i,j,l3)+taux(i-1,j,l3))*w3)
     .       *g/(p(i,j,2)+p(i-1,j,2))
c
 69   gradx(i,j)=-stresx*scu(i) + .5*((p(i,j,2)-p(i-1,j,2))*thref*
     .(1.-thbase-(thmix(i,j,m)*p(i,j,2)+thmix(i-1,j,m)*p(i-1,j,2))
     .          /(             p(i,j,2)               +p(i-1,j,2)))
     .+(montg(i  ,j,1)+montg(i  ,j,2)-p(i  ,j,2)*th2)
     .-(montg(i-1,j,1)+montg(i-1,j,2)-p(i-1,j,2)*th2))
c
      do 70 l=1,isv(j)
      do 70 i=ifv(j,l),ilv(j,l)
      vbrhs(i,j)=
     .-(ubavg(i,j  ,m)*depthu(i,j  )+ubavg(i+1,j  ,m)*depthu(i+1,j  )
     . +ubavg(i,ja ,m)*depthu(i,ja )+ubavg(i+1,ja ,m)*depthu(i+1,ja ))
     . *(pvtrop(i,j)+pvtrop(i+1,j))*.125
c
      stresy=((tauy(i,j,l0)+tauy(i,ja ,l0))*w0
     .       +(tauy(i,j,l1)+tauy(i,ja ,l1))*w1
     .       +(tauy(i,j,l2)+tauy(i,ja ,l2))*w2
     .       +(tauy(i,j,l3)+tauy(i,ja ,l3))*w3)
     .       *g/(p(i,j,2)+p(i,ja ,2))
c
 70   grady(i,j)=-stresy*scv(i) + .5*((p(i,j,2)-p(i,ja ,2))*thref*
     .(1.-thbase-(thmix(i,j,m)*p(i,j,2)+thmix(i,ja ,m)*p(i,ja ,2))
     .          /(             p(i,j,2)               +p(i,ja ,2)))
     .+(montg(i,j  ,1)+montg(i,j  ,2)-p(i,j  ,2)*th2)
     .-(montg(i,ja ,1)+montg(i,ja ,2)-p(i,ja ,2)*th2))
c
      return
      end
