      subroutine momeq2(m,n,mm,nn,k1m,k1n)
c
c --- version 2.6 -- cyclic in j
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common/linepr/lp
c
      real botstr(idm,jdm),dpmx(idm,jdm),dpxy,dpia,dpib,dpja,dpjb,
     .     visca,viscb,ptopl,pbotl,q
      integer lp
c
      include 'stmt_functions.h'
c
      do 804 j=1,jj
      do 804 i=1,ii
c --- spatial weighting function for pressure gradient calculation:
      util1(i,j)=0.
 804  util2(i,j)=0.
c
      do 9 k=1,kk
      km=k+mm
      kn=k+nn
c
c --- store total (barotropic plus baroclinic) flow at old and mid time in
c --- -utotn,vtotn- and -utotm,vtotm- respectively. store minimum thickness
c --- values for use in pot.vort. calculation in -dpmx-.
c
      do 812 j=1,jj
      do 812 i=1,ii
 812  dpmx(i,j)=2.*onem
c
      do 802 j=1,jj
      do 802 l=1,isu(j)
      do 802 i=ifu(j,l),ilu(j,l)
      dpmx(i,j  )=max(dpmx(i,j  ),dp(i,j,km)+dp(i-1,j,km))
      utotm(i,j)=u(i,j,km)+ubavg(i,j,m)
      utotn(i,j)=u(i,j,kn)+ubavg(i,j,n)
      uflux(i,j)=utotm(i,j)*max(dpu(i,j,km),onem)
 802  pu(i,j,k+1)=pu(i,j,k)+dpu(i,j,km)
c
      do 807 j=1,jj
      jb=mod(j     ,jj)+1
      do 807 l=1,isu(j)
      do 807 i=ifu(j,l),ilu(j,l)
 807  dpmx(i,jb )=max(dpmx(i,jb ),dp(i,j,km)+dp(i-1,j,km))
c
      do 803 i=1,ii1
      do 803 l=1,jsv(i)
      do 803 j=jfv(i,l),jlv(i,l)
      ja=mod(j-2+jj,jj)+1
      dpmx(i  ,j)=max(dpmx(i  ,j),dp(i,j,km)+dp(i,ja ,km))
      vtotm(i,j)=v(i,j,km)+vbavg(i,j,m)
      vtotn(i,j)=v(i,j,kn)+vbavg(i,j,n)
      vflux(i,j)=vtotm(i,j)*max(dpv(i,j,km),onem)
 803  pv(i,j,k+1)=pv(i,j,k)+dpv(i,j,km)
c
      do 808 i=1,ii1
      do 808 l=1,jsv(i)
      do 808 j=jfv(i,l),jlv(i,l)
      ja=mod(j-2+jj,jj)+1
 808  dpmx(i+1,j)=max(dpmx(i+1,j),dp(i,j,km)+dp(i,ja ,km))
c
c --- define auxiliary velocity fields (via,vib,uja,ujb) to implement
c --- sidewall friction along near-vertical bottom slopes. wgtja,wgtjb,wgtia,
c --- wgtib indicate the extent to which a sidewall is present.
c
      do 885 j=1,jj
      ja=mod(j-2+jj,jj)+1
      jb=mod(j     ,jj)+1
      do 805 l=1,isu(j)
      do 805 i=ifu(j,l),ilu(j,l)
      wgtja(i,j)=max(0.,min(1.,(pu(i,j,k+1)-depthu(i,ja))
     .          /max(pu(i,j,k+1)-pu(i,j,k),epsil)))
      wgtjb(i,j)=max(0.,min(1.,(pu(i,j,k+1)-depthu(i,jb))
     .          /max(pu(i,j,k+1)-pu(i,j,k),epsil)))
      uja(i,j)=(1.-wgtja(i,j))*utotn(i,ja)+wgtja(i,j)*slip*utotn(i,j)
 805  ujb(i,j)=(1.-wgtjb(i,j))*utotn(i,jb)+wgtjb(i,j)*slip*utotn(i,j)
c
c --- vorticity, pot.vort., defor. at lateral boundary points
      do 885 l=1,isv(j)
      i=ifv(j,l)
      vort(i  ,j)= vtotm(i,j)*(1.-slip)*scui(i)
      potvor(i  ,j)=(vort(i  ,j)+corio(i  ,j))
     ./(max(4.*(dp(i,j,km)+dp(i,ja ,km)),dpmx(i,j),dpmx(i+1,j))*.125)
      defor2(i  ,j)=(vtotn(i,j)*(1.-slip))**2
      i=ilv(j,l)
      vort(i+1,j)=-vtotm(i,j)*(1.-slip)*scui(i)
      potvor(i+1,j)=(vort(i+1,j)+corio(i+1,j))
     ./(max(4.*(dp(i,j,km)+dp(i,ja ,km)),dpmx(i,j),dpmx(i+1,j))*.125)
 885  defor2(i+1,j)=(vtotn(i,j)*(1.-slip))**2
c
      do 886 i=1,ii1
c --- if i=1, i-1 must point to zero-filled row (same for i+1 in case i=ii1)
      ia=mod(i-2+ii,ii)+1
      ib=i+1
      do 806 l=1,jsv(i)
      do 806 j=jfv(i,l),jlv(i,l)
      wgtia(i,j)=max(0.,min(1.,(pv(i,j,k+1)-depthv(ia,j))
     .          /max(pv(i,j,k+1)-pv(i,j,k),epsil)))
      wgtib(i,j)=max(0.,min(1.,(pv(i,j,k+1)-depthv(ib,j))
     .          /max(pv(i,j,k+1)-pv(i,j,k),epsil)))
      via(i,j)=(1.-wgtia(i,j))*vtotn(ia,j)+wgtia(i,j)*slip*vtotn(i,j)
 806  vib(i,j)=(1.-wgtib(i,j))*vtotn(ib,j)+wgtib(i,j)*slip*vtotn(i,j)
c
c --- vorticity, pot.vort., defor. at lateral boundary points
      do 886 l=1,jsu(i)
c
      j=jfu(i,l)
      if (j.ne.1  .or. jlu(i,jsu(i)).ne.jj) then
      jb=mod(j     ,jj)+1
      vort(i,j  )=-utotm(i,j)*(1.-slip)*scui(i)
      potvor(i,j  )=(vort(i,j  )+corio(i,j  ))
     ./(max(4.*(dp(i,j,km)+dp(ia ,j,km)),dpmx(i,j),dpmx(i,jb ))*.125)
      defor2(i,j  )=(utotn(i,j)*(1.-slip))**2
      end if
c
      j=jlu(i,l)
      if (j.ne.jj .or. jfu(i,     1).ne.1 ) then
      jb=mod(j     ,jj)+1
      vort(i,jb )= utotm(i,j)*(1.-slip)*scui(i)
      potvor(i,jb )=(vort(i,jb )+corio(i,jb ))
     ./(max(4.*(dp(i,j,km)+dp(ia ,j,km)),dpmx(i,j),dpmx(i,jb ))*.125)
      defor2(i,jb )=(utotn(i,j)*(1.-slip))**2
      end if
 886  continue
c
      do 63 j=1,jj
      jb=mod(j     ,jj)+1
      do 63 l=1,isp(j)
      do 63 i=ifp(j,l),ilp(j,l)
 63   defor1(i,j)=((utotn(i+1,j)-utotn(i,j))
     .            -(vtotn(i,jb )-vtotn(i,j)))**2
c
c --- vorticity, pot.vort., defor. at interior points (incl. promontories)
      do 64 j=1,jj
      ja=mod(j-2+jj,jj)+1
      jb=mod(j     ,jj)+1
      do 64 l=1,isq(j)
      do 64 i=ifq(j,l),ilq(j,l)
      vort(i,j)=(vtotm(i,j)*scv(i)-vtotm(i-1,j)*scv(i-1)
     .          -utotm(i,j)*scu(i)+utotm(i,ja )*scu(i  ))*scu2i(i)
      potvor(i,j)=(vort(i,j)+corio(i,j))
     ./(max(2.*(dp(i,j,km)+dp(i-1,j,km)+dp(i,ja ,km)+dp(i-1,ja ,km))
     .,dpmx(i,j),dpmx(i-1,j),dpmx(i+1,j),dpmx(i,ja ),dpmx(i,jb ))*.125)
 64   defor2(i,j)=(vtotn(i,j)-via(i,j)
     .            +utotn(i,j)-uja(i,j))**2
c
c --- ----------
c --- u equation
c --- ----------
c
c --- deformation-dependent eddy viscosity coefficient
c
      do 37 j=1,jj
      jb=mod(j     ,jj)+1
      do 37 l=1,isu(j)
c
      do 47 i=ifu(j,l),ilu(j,l)
 47   visc(i,j)=scu(i)*max(veldff,viscos*
     .sqrt(.5*(defor1(i,j)+defor1(i-1,j)+defor2(i,j)+defor2(i,jb ))))
c
      visc(ifu(j,l)-1,j)=visc(ifu(j,l),j)
 37   visc(ilu(j,l)+1,j)=visc(ilu(j,l),j)
c
      do 820 j=1,jj
      ja=mod(j-2+jj,jj)+1
      jb=mod(j     ,jj)+1
      do 820 l=1,isu(j)
c
c --- longitudinal turb. momentum flux (at mass points)
c
      do 824 i=ifu(j,l)-1,ilu(j,l)
 824  uflux1(i,j)=.5*(visc(i,j)+visc(i+1,j))*(utotn(i,j)-utotn(i+1,j))
     .             *harmon(max(dpu(i  ,j,km),onemm),
     .                     max(dpu(i+1,j,km),onemm))
c
c --- lateral turb. momentum flux (at vorticity points)
c --- (left and right fluxes are evaluated separately because of sidewalls)
c
      do 820 i=ifu(j,l),ilu(j,l)
      dpxy=max(dpu(i,j ,km),onemm)
      dpja=max(dpu(i,ja,km),onemm)
      dpjb=max(dpu(i,jb,km),onemm)
      if (iu(i,ja).eq.0) then
        visca=visc(i,j )
      else
        visca=visc(i,ja)
      end if
      if (iu(i,jb).eq.0) then
        viscb=visc(i,j )
      else
        viscb=visc(i,jb)
      end if
      uflux2(i,j)=.5*(visc(i,j)+visca)*(uja(i,j)-utotn(i,j))
     .            *harmon(dpja+wgtja(i,j)*(dpxy-dpja),dpxy)
      uflux3(i,j)=.5*(visc(i,j)+viscb)*(utotn(i,j)-ujb(i,j))
     .            *harmon(dpjb+wgtjb(i,j)*(dpxy-dpjb),dpxy)
c
c --- spatial weighting function for pressure gradient calculation:
      util1(i,j)=max(0.,min(depthu(i,j)-pu(i,j,k),
     .           pu(i,j,k+1)-pu(i,j,2),h1))
 820  pgfx(i,j)=(montg(i,j,k)-montg(i-1,j,k))*util1(i,j)
c
      do 6 j=1,jj
      ja=mod(j-2+jj,jj)+1
      jb=mod(j     ,jj)+1
      do 6 l=1,isu(j)
c
      if (k.gt.1) then
c
c --- pressure force in x direction
c --- ('scheme 2' from appendix -a- in bleck-smith paper)
c
      do 98 i=ifu(j,l),ilu(j,l)
 98   gradx(i,j)=(pgfx(i,j)+(h1-util1(i,j))*
     .  (pgfx (i-1,j)+pgfx (i+1,j)+pgfx (i,ja )+pgfx (i,jb ))/
     .  (util1(i-1,j)+util1(i+1,j)+util1(i,ja )+util1(i,jb )+epsil))/h1
      endif
c
      do 6 i=ifu(j,l),ilu(j,l)
c
      ptopl=min(depthu(i,j),.5*(p(i,j,k  )+p(i-1,j,k  )))
      pbotl=min(depthu(i,j),.5*(p(i,j,k+1)+p(i-1,j,k+1)))
c
c --- bottom boundary layer stress. stress profile is assumed linear
c --- with modifications to account for thin, high-velocity layers.
      botstr(i,j)=-utotn(i,j)*.5*(drag(i,j)+drag(i-1,j))*
     .     (max(depthu(i,j)-thkbot,          pbotl       )
     .     -max(depthu(i,j)-thkbot,min(ptopl,pbotl-onemm)))
     .     /max(dpu(i,j,km),onemm)
c
      uold(i,j,k)=u(i,j,kn)
 6    u(i,j,kn)=u(i,j,kn)+delt1*(-gradx(i,j)*scui(i)
     .-.25*(utotm(i+1,j)**2+vtotm(i  ,j)**2+vtotm(i  ,jb )**2
     .     -utotm(i-1,j)**2-vtotm(i-1,j)**2-vtotm(i-1,jb )**2)*scui(i)
     .+.125*(vflux(i  ,j)+vflux(i  ,jb )+vflux(i-1,j)+vflux(i-1,jb ))
     .     *(potvor(i,j)+potvor(i,jb )) - ubrhs(i,j) + botstr(i,j)
     .-(uflux1(i,j)-uflux1(i-1,j)
     . +uflux3(i,j)-uflux2(i,j))/(scu2(i)*max(dpu(i,j,km),onemm)))
c
cdiag if (k.eq.1) then
cdiag write (lp,'(i9,8x,''uold     unew    gradp   nonlin    corio'',
cdiag.4x,''ubrhs   botstr    fric'')') nstep
cdiag do j=jtest-1,jtest+1
cdiag ja=mod(j-2+jj,jj)+1
cdiag jb=mod(j     ,jj)+1
cdiag do i=itest-1,itest+1
cdiag write (lp,'(3i4,8f9.3)') i,j,k,
cdiag.  uold(i,j,k),u(i,j,kn),-delt1*gradx(i,j)*scui(i),
cdiag.  -delt1*
cdiag. .25*(utotm(i+1,j)**2+vtotm(i  ,j)**2+vtotm(i  ,jb )**2
cdiag.     -utotm(i-1,j)**2-vtotm(i-1,j)**2-vtotm(i-1,jb )**2)*scui(i),
cdiag.   delt1*(vflux(i  ,j)+vflux(i  ,jb )+vflux(i-1,j)+vflux(i-1,jb ))
cdiag.        *(potvor(i,j)+potvor(i,jb ))*.125,
cdiag.  -delt1*ubrhs(i,j),delt1*botstr(i,j),
cdiag.  -delt1*(uflux1(i,j)-uflux1(i-1,j)
cdiag.         +uflux3(i,j)-uflux2(i,j))/
cdiag.         (scu2(i)*max(dpu(i,j,km),onemm))
cdiag end do
cdiag end do
cdiag end if
c
c --- ----------
c --- v equation
c --- ----------
c
c --- deformation-dependent eddy viscosity coefficient
c
      do 38 i=1,ii1
      do 38 l=1,jsv(i)
c
      do 48 j=jfv(i,l),jlv(i,l)
      ja=mod(j-2+jj,jj)+1
 48   visc(i,j)=scv(i)*max(veldff,viscos*
     .sqrt(.5*(defor1(i,j)+defor1(i,ja )+defor2(i,j)+defor2(i+1,j))))
c
      j=jfv(i,l)
      ja=mod(j-2+jj,jj)+1
      if (j.ne.1  .or. jlv(i,jsv(i)).ne.jj) visc(i,ja)=visc(i,j)
      j=jlv(i,l)
      jb=mod(j     ,jj)+1
      if (j.ne.jj .or. jfv(i,     1).ne.1 ) visc(i,jb)=visc(i,j)
 38   continue
c
      do 821 i=1,ii1
c --- if i=1, i-1 must point to zero-filled row (same for i+1 in case i=ii1)
      ia=mod(i-2+ii,ii)+1
      ib=i+1
      do 821 l=1,jsv(i)
c
c --- longitudinal turb. momentum flux (at mass points)
c
      do 826 jp=jfv(i,l)-1,jlv(i,l)
      j=mod(jp-1+jj,jj)+1
      jb=mod(j     ,jj)+1
      if (jp.ne.0 .or. jfv(i,jsv(i)).ne.jj)
     .vflux1(i,j)=.5*(visc(i,j)+visc(i,jb ))*(vtotn(i,j)-vtotn(i,jb ))
     .             *harmon(max(dpv(i,j  ,km),onemm),
     .                     max(dpv(i,jb ,km),onemm))
 826  continue
c
c --- lateral turb. momentum flux (at vorticity points)
c --- (left and right fluxes are evaluated separately because of sidewalls)
c
      do 821 j=jfv(i,l),jlv(i,l)
      ja=mod(j-2+jj,jj)+1
      dpxy=max(dpv(i ,j,km),onemm)
      dpia=max(dpv(ia,j,km),onemm)
      dpib=max(dpv(ib,j,km),onemm)
      if (iv(ia,j).eq.0) then
        visca=visc(i ,j)
      else
        visca=visc(ia,j)
      end if
      if (iv(ib,j).eq.0) then
        viscb=visc(i ,j)
      else
        viscb=visc(ib,j)
      end if
      vflux2(i,j)=.5*(visc(i,j)+visca)*(via(i,j)-vtotn(i,j))
     .            *harmon(dpia+wgtia(i,j)*(dpxy-dpia),dpxy)
      vflux3(i,j)=.5*(visc(i,j)+viscb)*(vtotn(i,j)-vib(i,j))
     .            *harmon(dpib+wgtib(i,j)*(dpxy-dpib),dpxy)
c
c --- spatial weighting function for pressure gradient calculation:
      util2(i,j)=max(0.,min(depthv(i,j)-pv(i,j,k),
     .           pv(i,j,k+1)-pv(i,j,2),h1))
 821  pgfy(i,j)=(montg(i,j,k)-montg(i,ja ,k))*util2(i,j)
c
      do 7 i=1,ii1
c --- if i=1, i-1 must point to zero-filled row (same for i+1 in case i=ii1)
      ia=mod(i-2+ii,ii)+1
      ib=i+1
      do 7 l=1,jsv(i)
c
      if (k.gt.1) then
c
c --- pressure force in y direction
c --- ('scheme 2' from appendix -a- in bleck-smith paper)
c
      do 99 j=jfv(i,l),jlv(i,l)
      ja=mod(j-2+jj,jj)+1
      jb=mod(j     ,jj)+1
 99   grady(i,j)=(pgfy(i,j)+(h1-util2(i,j))*
     .  (pgfy (ia ,j)+pgfy (ib ,j)+pgfy (i,ja )+pgfy (i,jb ))/
     .  (util2(ia ,j)+util2(ib ,j)+util2(i,ja )+util2(i,jb )+epsil))/h1
      endif
c
      do 7 j=jfv(i,l),jlv(i,l)
      ja=mod(j-2+jj,jj)+1
      jb=mod(j     ,jj)+1
c
      ptopl=min(depthv(i,j),.5*(p(i,j,k  )+p(i,ja ,k  )))
      pbotl=min(depthv(i,j),.5*(p(i,j,k+1)+p(i,ja ,k+1)))
c
c --- bottom boundary layer stress. stress profile is assumed linear
c --- with modifications to account for thin, high-velocity layers.
      botstr(i,j)=-vtotn(i,j)*.5*(drag(i,j)+drag(i,ja ))*
     .     (max(depthv(i,j)-thkbot,          pbotl       )
     .     -max(depthv(i,j)-thkbot,min(ptopl,pbotl-onemm)))
     .     /max(dpv(i,j,km),onemm)
c
      vold(i,j,k)=v(i,j,kn)
 7    v(i,j,kn)=v(i,j,kn)+delt1*(-grady(i,j)*scvi(i)
     .-.25*(vtotm(i,jb )**2+utotm(i,j  )**2+utotm(i+1,j  )**2
     .     -vtotm(i,ja )**2-utotm(i,ja )**2-utotm(i+1,ja )**2)*scvi(i)
     .-.125*(uflux(i,j  )+uflux(i+1,j  )+uflux(i,ja )+uflux(i+1,ja ))
     .     *(potvor(i,j)+potvor(i+1,j)) - vbrhs(i,j) + botstr(i,j)
     .-(vflux1(i,j)-vflux1(i,ja )
     . +vflux3(i,j)-vflux2(i,j))/(scv2(i)*max(dpv(i,j,km),onemm)))
c
cdiag if (k.eq.1) then
cdiag write (lp,'(i9,8x,''vold     vnew    gradp   nonlin    corio'',
cdiag.4x,''vbrhs   botstr    fric'')') nstep
cdiag do j=jtest-1,jtest+1
cdiag ja=mod(j-2+jj,jj)+1
cdiag jb=mod(j     ,jj)+1
cdiag do i=itest-1,itest+1
cdiag write (lp,'(3i4,8f9.3)') i,j,k,
cdiag.  vold(i,j,k),v(i,j,kn),-delt1*grady(i,j)*scvi(i),
cdiag.  -delt1*
cdiag. .25*(vtotm(i,jb )**2+utotm(i,j  )**2+utotm(i+1,j  )**2
cdiag.     -vtotm(i,ja )**2-utotm(i,ja )**2-utotm(i+1,ja )**2)*scvi(i),
cdiag.  -delt1*(uflux(i,j  )+uflux(i+1,j  )+uflux(i,ja )+uflux(i+1,ja ))
cdiag.        *(potvor(i,j)+potvor(i+1,j))*.125,
cdiag.  -delt1*vbrhs(i,j),delt1*botstr(i,j),
cdiag.  -delt1*(vflux1(i,j)-vflux1(i,ja )
cdiag.         +vflux3(i,j)-vflux2(i,j))/
cdiag.         (scv2(i)*max(dpv(i,j,km),onemm))
cdiag end do
cdiag end do
cdiag end if
c
 9    continue
c
      return
      end
