      subroutine mxlayr(m,n,mm,nn,k1m,k1n)
c
c --- version 2.6 -- cyclic in j
      implicit none
c
      common/linepr/lp
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      real x,ccubq,ccubr,ccubqr,ccubs1,ccubs2,ccubrl,ccubim,root,root1,
     .     root2,root3
      real dpth,ekminv,obuinv,ex,alf1,alf2,cp1,cp3,ape,cc4,spe,em,en,
     .     work(3),ea1,ea2,em1,em2,em3,em4,em5,thknss,ustar3,pnew,
     .     tmxl,smxl,dpkn,tkn,skn,dtemp,dsaln,fossl,z,d,e,f,
     .     cc0,cc1,cc2,cc3,thk,delp,q,c1msig
      integer lp,num,nu
c
      data ea1, ea2, em1, em2, em3, em4, em5
     .   /0.60,0.30,0.45,2.60,1.90,2.30,0.60/          ! Gaspar coefficients
c
      include 'stmt_functions.h'
c
c --- cubic eqn. solver used in mixed-layer detrainment
      ccubq(x)=athird*(cc1/cc3-athird*(cc2/cc3)**2)
      ccubr(x)=athird*(.5*(cc1*cc2)/(cc3*cc3)-1.5*cc0/cc3)
     .       -(athird*cc2/cc3)**3
      ccubqr(x)=sqrt(abs(ccubq(x)**3+ccubr(x)**2))
      ccubs1(x)=sign(abs(ccubr(x)+ccubqr(x))**athird,ccubr(x)+ccubqr(x))
      ccubs2(x)=sign(abs(ccubr(x)-ccubqr(x))**athird,ccubr(x)-ccubqr(x))
      root(x)=ccubs1(x)+ccubs2(x)-athird*cc2/cc3
      ccubrl(x)=sqrt(max(0.,-ccubq(x)))
     .          *cos(athird*atan2(ccubqr(x),ccubr(x)))
      ccubim(x)=sqrt(max(0.,-ccubq(x)))
     .          *sin(athird*atan2(ccubqr(x),ccubr(x)))
      root1(x)=2.*ccubrl(x)-athird*cc2/cc3
      root2(x)=-ccubrl(x)+sqrt(3.)*ccubim(x)-athird*cc2/cc3
      root3(x)=-ccubrl(x)-sqrt(3.)*ccubim(x)-athird*cc2/cc3
c
      if (thermo) then
c
c --- -----------------------------------
c --- mixed layer entrainment/detrainment
c --- -----------------------------------
c
      do 85 j=1,jj
      do 85 l=1,isp(j)
c
      do 86 i=ifp(j,l),ilp(j,l)
      thknss=dp(i,j,k1n)
      ustar3=ustar(i,j)**3
c
c --- determine turb.kin.energy generation due to wind stirring (ustar3) and
c --- diabatic forcing (buoyfl). ustar3,buoyfl are computed in subr. -thermf-
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c --- option 1 :   k r a u s  -  t u r n e r    mixed-layer t.k.e.  closure
c
ccc   em=0.8*exp(-p(i,j,2)/(50.*onem))  !   hadley centre choice (orig.: 1.25)
ccc   en=0.15                           !   hadley centre choice (orig.: 0.4)
ccc   thermg=.5*((en+1.)*buoyfl(i,j)+(en-1.)*abs(buoyfl(i,j)))
ccc   turgen(i,j)=delt1*(2.*em*g*ustar3/thref+thknss*thermg)/thref
c
c --- find monin-obukhov length in case of receding mixed layer (turgen < 0).
c --- the monin-obukhov length is found by stipulating turgen = 0.
c --- store temporarily in 'sdot'.
c
ccc   if (turgen(i,j).lt.0.) then
ccc     sdot(i,j)=-2.*em*g*ustar3/min(-epsil,thref*thermg)
ccc   else
ccc     sdot(i,j)=thknss
ccc   end if
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c --- option 2 :    g a s p a r   mixed-layer t.k.e. closure
c
      dpth=thknss/onecm
      ekminv=abs(corio(i,j))/max(epsil,ustar(i,j))
      obuinv=-buoyfl(i,j)/max(epsil,ustar3)
      ex=exp(min(50.,dpth*obuinv))
      alf1=ea1+ea2*max(1.,2.5*dpth*ekminv)*ex
      alf2=ea1+ea2*ex
      cp1=((1.-em5)*(alf1/alf2)+.5*em4)*athird
      cp3=max(0.,(em4*(em2+em3)-(alf1/alf2)*(em2+em3-em3*em5))*athird)
      ape=cp3*ustar3/thref+cp1*dpth*buoyfl(i,j)
c
      if(ape.lt.0.) then                                       ! detrainment
      turgen(i,j)=(g*delt1/thref)*ape
      sdot(i,j)=min(thknss,g*cp3/(cp1*max(epsil,obuinv)))
c
      else                                                     ! entrainment
      cc4=2.*em4/(em1*em1) * alf1*alf1
      spe=(em2+em3)*ustar3/thref+0.5*dpth*buoyfl(i,j)
      turgen(i,j)=(g*delt1/thref)*(sqrt((.5*ape-cp1*spe)**2
     .                 +2.*cc4*ape*spe)-(.5*ape+cp1*spe))/(cc4-cp1)
      sdot(i,j)=thknss
      end if
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c --- util1,util2 are used to evaluate pot.energy changes during entrainment
      util1(i,j)=thmix(i,j,n)*thknss
 86   util2(i,j)=thmix(i,j,n)*thknss**2
c
c --- find pnew in case of mixed layer deepening (turgen > 0). store in 'sdot'.
c --- entrain as many layers as needed to deplete -turgen-.
c
      do 85 k=2,kk
      kn=k+nn
      do 85 i=ifp(j,l),ilp(j,l)
      pnew=(2.*turgen(i,j)+theta(k)*p(i,j,k)**2-util2(i,j))/
     .           max(epsil,theta(k)*p(i,j,k)   -util1(i,j))
c --- stop iterating for 'pnew' as soon as pnew < k-th interface pressure
      if (pnew.lt.p(i,j,k)) pnew=sdot(i,j)
c --- substitute 'pnew' for monin-obukhov length if mixed layer is deepening
      if (turgen(i,j).ge.0.) sdot(i,j)=pnew
c
      util1(i,j)=util1(i,j)+theta(k)*dp(i,j,kn)
 85   util2(i,j)=util2(i,j)+theta(k)*(p(i,j,k+1)**2-p(i,j,k)**2)
c
      else				!  thermo = .false.
c
      do 87 j=1,jj
      do 87 l=1,isp(j)
      do 87 i=ifp(j,l),ilp(j,l)
      surflx(i,j)=0.
      salflx(i,j)=0.
 87   sdot(i,j)=dp(i,j,k1n)
c
      end if				!  thermo = .true. or .false.
c
cdiag if (itest.gt.0.and.jtest.gt.0.and.turgen(itest,jtest).lt.0.)
cdiag.write(lp,'(i9,2i4,'' monin-obukhov length (m):'',f8.2)') nstep,
cdiag.itest,jtest,sdot(itest,jtest)/onem
c
cmic$ do all  private(work,snew)  autoscope
      do 26 j=1,jj
      do 26 l=1,isp(j)
c
      do 42 i=ifp(j,l),ilp(j,l)
c --- store (pnew - pold) in 'sdot'.
c --- don't allow mixed layer to get too deep or too shallow.
      sdot(i,j)=min(p(i,j,kk+1),max(thkmin*onem,sdot(i,j)))
     .         -dp(i,j,k1n)
      klist(i,j)=2
      tdp(i,j)=0.
 42   sdp(i,j)=0.
c
      do 43 k=2,kk
      kn=k+nn
      do 43 i=ifp(j,l),ilp(j,l)
      pnew=dp(i,j,k1n)+sdot(i,j)
c --- 'tdp,sdp' will be needed for temp./salin. mixing during entrainment
      tdp(i,j)=tdp(i,j)+temp(i,j,kn)*(min(pnew,p(i,j,k+1))
     .                               -min(pnew,p(i,j,k  )))
      sdp(i,j)=sdp(i,j)+saln(i,j,kn)*(min(pnew,p(i,j,k+1))
     .                               -min(pnew,p(i,j,k  )))
c
c --- if sdot > 0, remove water from layers about to be entrained.
      dp(i,j,kn)=max(p(i,j,k+1),pnew)-max(p(i,j,k),pnew)
      if (pnew.ge.p(i,j,k+1)) tracer(i,j,k)=0.
c
c --- if sdot < 0, mixed layer water will be detrained into isopycnic layer
c --- defined in -klist-. to prevent odd/even time step decoupling of mixed-
c --- layer depth, determine -klist- from -thmix- at 2 consecutive time levels
c
      if (max(thmix(i,j,m),thmix(i,j,n))
ccc  .         +.0001*(theta(3)-theta(2)).ge.theta(k))
     .          +.001*(theta(3)-theta(2)).ge.theta(k))
     .     klist(i,j)=min(k+1,kk)
c
 43   continue
c
c --- redistribute temp. and salin. during both de- and entrainment
c
cdir$ ivdep
      do 26 i=ifp(j,l),ilp(j,l)
      thknss=dp(i,j,k1n)
      pnew=thknss+sdot(i,j)
c
      tmxl=temp(i,j,k1n)-surflx(i,j)*delt1*g/(spcifh*thknss)
      smxl=saln(i,j,k1n)-salflx(i,j)*delt1*g/        thknss
c
cdiag if (i.eq.itest.and.j.eq.jtest)
cdiag.write (lp,'(i9,3i4,'' t,s,dp after diab.forcing'',2f9.4,
cdiag.f8.2)') nstep,i,j,1,tmxl,smxl,dp(i,j,k1n)/onem
c
      if (sdot(i,j).ge.0.) then
c
c --- (mixed layer  d e e p e n s)
c
cdiag if (i.eq.itest.and.j.eq.jtest)
cdiag.write (lp,'(i9,2i4,'' entrain'',f9.3,'' m of water'')') nstep,i,j,
cdiag.sdot(i,j)/onem
c
      tmxl=(tmxl*thknss+tdp(i,j))/pnew
      smxl=(smxl*thknss+sdp(i,j))/pnew
      dp(i,j,k1n)=pnew
c
      else if (sdot(i,j).lt.-onecm.and.surflx(i,j).lt.0.) then       !  sdot < 0
c
c --- (mixed layer  r e c e d e s)
c
      k=klist(i,j)
      kn=k+nn
      dpkn=max(dp(i,j,kn),0.)
      skn=saln(i,j,kn)
      tkn=temp(i,j,kn)
c
cdiag if (i.eq.itest.and.j.eq.jtest)
cdiag.write (lp,'(i9,3i4,'' t,s,dp before detrainment'',2f9.4,f8.2)')
cdiag.nstep,i,j,k,tkn,skn,dpkn/onem
c
c --- distribute last time step's heating and freshwater flux over depth range
c --- 'pnew' (monin-obukhov length). split fossil mixed layer (depth= -sdot=
c --- thknss-pnew) into one part of depth z cooled and detrained into layer k,
c --- and one part heated to match temperature rise in mixed layer. transfer
c --- salinity from upper to lower part without creating new maxima/minima.
c
      dtemp=-surflx(i,j)*delt1*g/(spcifh*pnew)
ccc   dsaln=-salflx(i,j)*delt1*g/        pnew
c --- spread net salt gain over old depth, net salt loss over new depth
      dsaln=-delt1*g*(min(0.,salflx(i,j))/thknss
     .               +max(0.,salflx(i,j))/pnew)
      tmxl=temp(i,j,k1n)+dtemp
      smxl=saln(i,j,k1n)+dsaln
c
c --- scenario 1 (applicable only if precip > evap): transfer t/s within fossil
c --- mixed layer to make lower part (depth: z) match t/s in layer k while 
c --- heating upper part (depth: thknss-pnew-z) to mixed-layer temperature.
c
c --- fossl = salinity in upper part of fossil mixed layer after sal. transfer
      fossl=saln(i,j,k1n)+(saln(i,j,k1n)-skn)*dtemp
     .    /max(epsil*dtemp,temp(i,j,k1n)-tkn)
      z=-sdot(i,j)*min(1.,dtemp/max(epsil,tmxl-tkn))/onem
c
c --- does upper-part salinity fall within prescribed limits?
      if (fossl.ge.smxl .and. fossl.le.saln(i,j,k1n)) then
c
c --- scenario 1 accepted => layer k properties unchanged during detrainment
c
      else				!  scenario 2
c
c --- scenario 2: transfer temperature within fossil mixed layer to heat upper
c --- part (depth: thknss-pnew-z=-sdot-z) to mixed-layer temperature. transfer
c --- salinity downward without creating new salinity maxima/minima. emphasis 
c --- is on maintaining density in layer k during detrainment. This requires 
c --- solving 3rd deg. polynomial cc3*z**3 + cc2*z**2 + cc1*z + cc0 = 0 for z.
c
ccc   dsaln=min(0.,dsaln)
      fossl=saln(i,j,k1n)+dsaln
c
c --- new (t,s) in layer  k  will be t=(a*z+b)/(z+d), s=(e*z+f)/(z+d).
      a=tmxl
      e=fossl
ccc   b=(tkn*dpkn+dtemp*sdot(i,j))/onem
ccc   f=(skn*dpkn+dsaln*sdot(i,j))/onem
      b=(tkn*dpkn+       dtemp *sdot(i,j))/onem
      f=(skn*dpkn+min(0.,dsaln)*sdot(i,j))/onem
      d=dpkn/onem
c
      c1msig=c1-(theta(k)+thbase)*1.e3/thref
      cc0=d*d*(d*c1msig+b*c2+f*c3)+b*(d*f*c5+b*(d*c4+b*c6+f*c7))
      cc3=    (  c1msig+a*c2+e*c3)+a*(  e*c5+a*(  c4+a*c6+e*c7))
      cc1=d*(3.  *d*c1msig+(2.*b  +a*d)*c2+(2.  *f+d*e)*c3)+b*((2.*a*d
     .    +b  )*c4+3.*a*b*c6+(2.*a*f+b*e)*c7)+(a*d*f+b*(d*e+  f))*c5
      cc2=  (3.  *d*c1msig+(2.*a*d+b  )*c2+(2.*d*e+  f)*c3)+a*((2.*b
     .    +a*d)*c4+3.*a*b*c6+(2.*b*e+a*f)*c7)+(b  *e+a*(  f+d*e))*c5
c --- bound cc3 away from zero
      cc3=sign(max(1.e-6,abs(cc3)),cc3)
c
      if (ccubq(x)**3+ccubr(x)**2.gt.0.) then
c --- one real root
      num=1
      z=root(x)
      else
c --- three real roots
      num=3
      z=root1(x)
      end if
c
cdiag if (i.eq.itest.and.j.eq.jtest) then
cdiag work(1)=z
cdiag if (num.eq.3) then
cdiag work(2)=root2(x)
cdiag work(3)=root3(x)
cdiag end if
cdiag write (lp,'(i9,2i4,'' t,s,dp( 1)='',2f7.3,f8.2,3x,''sdot,z='',
cdiag.2f8.2/18x,''t,s,dp('',i2,'')='',2f7.3,f8.2,3x,''real root(s):'',
cdiag.1p3e11.4)') nstep,i,j,tmxl,smxl,thknss/onem,sdot(i,j)/onem,z,k,
cdiag.tkn,skn,dpkn/onem,(work(nu),nu=1,num)
cdiag end if
c
c --- does root fall into appropriate range?
      if (z.le.0.005) go to 27
c
c --- ready to detrain lowest 'z' meters from mixed layer
c
      temp(i,j,kn)=(a*z+b)/(z+d)
      saln(i,j,kn)=(e*z+f)/(z+d)
c
      end if				!  scenario 1 or 2
c
      sdot(i,j)=max(sdot(i,j),-z*onem)
      dp(i,j,k1n)=thknss+sdot(i,j)
      dp(i,j,kn) =dpkn  -sdot(i,j)
      smxl=(smxl*pnew+fossl*(dp(i,j,k1n)-pnew))/dp(i,j,k1n)
c
c --- inject 'ventilation' tracer into layer k
      if (trcout) then
      tracer(i,j,k)=(tracer(i,j,k)*dpkn-sdot(i,j))
     .                           /(dpkn-sdot(i,j))
      end if
c
cdiag if (i.eq.itest.and.j.eq.jtest)
cdiag.write (lp,'(i9,3i4,'' t,s,dp after  detrainment'',2f9.4,f8.2)')
cdiag.nstep,i,j,k,temp(i,j,kn),saln(i,j,kn),dp(i,j,kn)/onem
c
      end if				!  sdot > or < 0
c
 27   temp(i,j,k1n)=tmxl
      saln(i,j,k1n)=smxl
c
cdiag if (i.eq.itest.and.j.eq.jtest)
cdiag.write (lp,'(i9,3i4,'' final mixed-layer t,s,dp '',2f9.4,f8.2)')
cdiag.nstep,i,j,1,tmxl,smxl,dp(i,j,k1n)/onem
c
 26   thmix(i,j,n)=sig(tmxl,smxl)-thbase
c
c --- store 'old' interface pressures in -pu,pv-
c
      do 882 k=2,kk+1
      do 882 j=1,jj
      ja=mod(j-2+jj,jj)+1
c
      do 881 l=1,isu(j)
      do 881 i=ifu(j,l),ilu(j,l)
 881  pu(i,j,k)=min(depthu(i,j),.5*(p(i,j,k)+p(i-1,j,k)))
c
      do 882 l=1,isv(j)
      do 882 i=ifv(j,l),ilv(j,l)
 882  pv(i,j,k)=min(depthv(i,j),.5*(p(i,j,k)+p(i,ja ,k)))
c
c --- store 'new' layer thicknesses in -dpu,dpv-
c
      do 883 j=1,jj
      do 883 k=1,kk
      do 883 l=1,isp(j)
      do 883 i=ifp(j,l),ilp(j,l)
 883  p(i,j,k+1)=p(i,j,k)+dp(i,j,k+nn)
c
      call dpudpv(p,depthu,depthv,dpu(1,1,1+nn),dpv(1,1,1+nn))
c
c --- redistribute momentum in the vertical.
c --- homogenize (u,v) over depth range defined in -util1,util2-
c
c --- thk>0 activates momentum diffusion across mixed-layer interface
      thk=vertmx*onecm*delt1
c
      do 97 j=1,jj
c
      do 83 l=1,isu(j)
c
      do 822 i=ifu(j,l),ilu(j,l)
      util1(i,j)=max(dpu(i,j,k1n),pu(i,j,2)+thk)
      uflux(i,j)=0.
 822  util3(i,j)=0.
c
      do 82 k=1,kk
      do 82 i=ifu(j,l),ilu(j,l)
      delp=max(0.,min(util1(i,j),pu(i,j,k+1))
     .           -min(util1(i,j),pu(i,j,k  )))
      uflux(i,j)=uflux(i,j)+u(i,j,k+nn)*delp
 82   util3(i,j)=util3(i,j)            +delp
c
      do 83 i=ifu(j,l),ilu(j,l)
 83   u(i,j,k1n)=uflux(i,j)/util3(i,j)
c
      do 84 l=1,isv(j)
c
      do 844 i=ifv(j,l),ilv(j,l)
      util2(i,j)=max(dpv(i,j,k1n),pv(i,j,2)+thk)
      vflux(i,j)=0.
 844  util4(i,j)=0.
c
      do 80 k=1,kk
      do 80 i=ifv(j,l),ilv(j,l)
      delp=max(0.,min(util2(i,j),pv(i,j,k+1))
     .           -min(util2(i,j),pv(i,j,k  )))
      vflux(i,j)=vflux(i,j)+v(i,j,k+nn)*delp
 80   util4(i,j)=util4(i,j)            +delp
c
      do 84 i=ifv(j,l),ilv(j,l)
 84   v(i,j,k1n)=vflux(i,j)/util4(i,j)
c
      do 97 k=2,kk
      kn=k+nn
c
      do 96 l=1,isu(j)
      do 96 i=ifu(j,l),ilu(j,l)
      pu(i,j,k)=pu(i,j,k-1)+dpu(i,j,kn-1)
      q=max(0.,min(1.,(util1(i,j)-pu(i,j,k))/(dpu(i,j,kn)+epsil)))
 96   u(i,j,kn)=u(i,j,k1n)*q+u(i,j,kn)*(1.-q)
c
      do 97 l=1,isv(j)
      do 97 i=ifv(j,l),ilv(j,l)
      pv(i,j,k)=pv(i,j,k-1)+dpv(i,j,kn-1)
      q=max(0.,min(1.,(util2(i,j)-pv(i,j,k))/(dpv(i,j,kn)+epsil)))
 97   v(i,j,kn)=v(i,j,k1n)*q+v(i,j,kn)*(1.-q)
c
      return
      end
