      subroutine tsadvc(m,n,mm,nn,k1m,k1n)
c
c --- version 2.6 -- cyclic in j
      implicit none
c
      include 'dimensions.h'
      include 'common_blocks.h'
c
      common/linepr/lp
c
      real smin,smax,tmin,tmax,sminn,smaxx,tminn,tmaxx,posdef,flxdiv
     .    ,offset,factor,q,pold,pmid,pnew
      integer lp
c
      include 'stmt_functions.h'
c
      do 81 k=1,kk
      km=k+mm
      kn=k+nn
c
      smin=999.
      tmin=999.
      smax=-999.
      tmax=-999.
      sminn=999.
      tminn=999.
      smaxx=-999.
      tmaxx=-999.
c
      if (k.eq.1) then
c --- ---------------------------------------------------
c --- advection of thermodynamic variables in mixed layer
c --- ---------------------------------------------------
c
cdiag if (itest.gt.0.and.jtest.gt.0) write
cdiag.(lp,'(i9,2i4,'' sigma/saln before advection:'',3pf8.3,0pf8.3)')
cdiag.nstep,itest,jtest,thmix(itest,jtest,n)+thbase,saln(itest,jtest,kn)
c
c --- smooth mixed-layer mass fluxes in lateral direction
      do 791 j=1,jj
      do 791 l=1,isv(j)
      do 791 i=ifv(j,l),ilv(j,l)
      ia=max(i-1,ifv(j,l))
      ib=min(i+1,ilv(j,l))
 791  vflux(i,j)=.5*vflx(i,j,1)+.25*(vflx(ia,j,1)+vflx(ib,j,1))
c
      do 792 i=1,ii1
      wrap=jfv(i,1).eq.1        !  true if j=1 and j=jj are both water points
      do 792 l=1,jsu(i)
      do 792 j=jfu(i,l),jlu(i,l)
      ja=max(j-1,jfu(i,l))
      jb=min(j+1,jlu(i,l))
      if (wrap .and. j.eq.1) ja=jj
      if (wrap .and. j.eq.jj) jb=1
 792  uflux(i,j)=.5*uflx(i,j,1)+.25*(uflx(i,ja,1)+uflx(i,jb,1))
c
      posdef=thbase
c
      do 491 j=1,jj
      jb=mod(j     ,jj)+1
      do 491 l=1,isp(j)
      do 491 i=ifp(j,l),ilp(j,l)
c
c --- time smoothing of mixed layer thermodynamic variables (part 1)
      pold=max(0.,dpold(i,j,k))
      pmid=max(0.,dp(i,j,km))
      saln(i,j,km)=saln(i,j,km)*(wts1*pmid+onemm)+wts2*saln(i,j,kn)*pold
      thmix(i,j,m)=thmix(i,j,m)*(wts1*pmid+onemm)+wts2*thmix(i,j,n)*pold
c
c --- before calling 'advem', make sure (a) mass fluxes are consistent
c --- with layer thickness change, and (b) all fields are positive-definite
      flxdiv=(uflux(i+1,j)-uflux(i,j)
     .       +vflux(i,jb )-vflux(i,j))*delt1*scp2i(i)
      util2(i,j)=.5*(dpold(i,j,k)+dp(i,j,kn)-flxdiv)
      util1(i,j)=.5*(dpold(i,j,k)+dp(i,j,kn)+flxdiv)
      offset=min(0.,util1(i,j),util2(i,j))
      util2(i,j)=util2(i,j)-offset
      util1(i,j)=util1(i,j)-offset
c
      smin=min(smin,saln(i,j,kn))
      smax=max(smax,saln(i,j,kn))
      tmin=min(tmin,thmix(i,j,n))
      tmax=max(tmax,thmix(i,j,n))
 491  thmix(i,j,n)=thmix(i,j,n)+posdef
c
      if (tmin+posdef.lt.0..or.smin.lt.0.) then
      do 460 j=1,jj
      do 460 l=1,isp(j)
      do 460 i=ifp(j,l),ilp(j,l)
      if (thmix(i,j,n).eq.tmin)
     . write (lp,'(i9,'' i,j,k='',3i4,'' neg. thmix before advem call'',
     . 1pe9.1)') nstep,i,j,k,tmin
      if (saln(i,j,kn).eq.smin)
     . write (lp,'(i9,'' i,j,k='',3i4,'' neg. salin before advem call'',
     . 1pe9.1)') nstep,i,j,k,smin
 460  continue
      end if
c
      call advem(2,thmix(1,1,n),uflux,vflux,scp2,scp2i,
     .           delt1,util1,util2)
      call advem(2,saln(1,1,kn),uflux,vflux,scp2,scp2i,
     .           delt1,util1,util2)
c
      do 461 j=1,jj
      do 461 l=1,isp(j)
      do 461 i=ifp(j,l),ilp(j,l)
      thmix(i,j,n)=thmix(i,j,n)-posdef
      sminn=min(sminn,saln(i,j,kn))
      smaxx=max(smaxx,saln(i,j,kn))
      tminn=min(tminn,thmix(i,j,n))
      tmaxx=max(tmaxx,thmix(i,j,n))
c
c --- time smoothing of thickness field
      pold=max(0.,dpold(i,j,k))
      pmid=max(0.,dp(i,j,km))
      pnew=max(0.,dp(i,j,kn))
      dp(i,j,km)=pmid*wts1+(pold+pnew)*wts2
c --- time smoothing of mixed layer thermodynamic variables (part 2)
      pmid=max(0.,dp(i,j,km))
      saln(i,j,km)=(saln(i,j,km)+wts2*saln(i,j,kn)*pnew)/(pmid+onemm)
 461  thmix(i,j,m)=(thmix(i,j,m)+wts2*thmix(i,j,n)*pnew)/(pmid+onemm)
c
      if (tminn+posdef.lt.0..or.sminn.lt.0.)
     . write (lp,'(i9,i4,'' neg. thmix/saln after  advem call  '',
     . 3pf9.2,0pf9.2)') nstep,k,tminn,sminn
c
cdiag if (itest.gt.0.and.jtest.gt.0) write
cdiag.(lp,'(i9,2i4,'' sigma/saln  after advection:'',3pf8.3,0pf8.3)')
cdiag.nstep,itest,jtest,thmix(itest,jtest,n)+thbase,saln(itest,jtest,kn)
c
c --- ---------------------------------------------------
c --- diffusion of thermodynamic variables in mixed layer
c --- ---------------------------------------------------
c
      do 451 j=1,jj
      ja=mod(j-2+jj,jj)+1
c
      do 441 l=1,isu(j)
      do 441 i=ifu(j,l),ilu(j,l)
      factor=scu(i)*harmon(max(dp(i-1,j,kn),onemm)
     .                    ,max(dp(i  ,j,kn),onemm))
      uflux2(i,j)=factor*(saln(i-1,j,kn)-saln(i,j,kn))
 441  uflux3(i,j)=factor*(thmix(i-1,j,n)-thmix(i,j,n))
c
      do 451 l=1,isv(j)
      do 451 i=ifv(j,l),ilv(j,l)
      factor=scv(i)*harmon(max(dp(i,ja ,kn),onemm)
     .                    ,max(dp(i,j  ,kn),onemm))
      vflux2(i,j)=factor*(saln(i,ja ,kn)-saln(i,j,kn))
 451  vflux3(i,j)=factor*(thmix(i,ja ,n)-thmix(i,j,n))
c
      do 462 j=1,jj
      jb=mod(j     ,jj)+1
      do 462 l=1,isp(j)
      do 462 i=ifp(j,l),ilp(j,l)
      factor=temdff*delt1/(scp2(i)*max(dp(i,j,kn),onemm))
      saln(i,j,kn)=saln(i,j,kn)-(uflux2(i+1,j)-uflux2(i,j)
     .                          +vflux2(i,jb )-vflux2(i,j))*factor
      thmix(i,j,n)=thmix(i,j,n)-(uflux3(i+1,j)-uflux3(i,j)
     .                          +vflux3(i,jb )-vflux3(i,j))*factor
 462  temp(i,j,kn)=tofsig(thmix(i,j,n)+thbase,saln(i,j,kn))
c
cdiag if (itest.gt.0.and.jtest.gt.0) write
cdiag.(lp,'(i9,2i4,'' sigma/saln  after diffusion:'',3pf8.3,0pf8.3)')
cdiag.nstep,itest,jtest,thmix(itest,jtest,n)+thbase,saln(itest,jtest,kn)
c
      else                !  k > 1
c --- ---------------------------------------------------------
c --- advection of thermodynamic variable(s) in interior layers
c --- ---------------------------------------------------------
c
      do 49 j=1,jj
      jb=mod(j     ,jj)+1
      do 49 l=1,isp(j)
      do 49 i=ifp(j,l),ilp(j,l)
c
c --- time smoothing of thermodynamic variable(s) (part 1)
      pold=max(0.,dpold(i,j,k))
      pmid=max(0.,dp(i,j,km))
      saln(i,j,km)=saln(i,j,km)*(wts1*pmid+onemm)+wts2*saln(i,j,kn)*pold
c
c --- before calling 'advem', make sure (a) mass fluxes are consistent
c --- with layer thickness change, and (b) all fields are positive-definite
      flxdiv=(uflx(i+1,j,k)-uflx(i,j,k)
     .       +vflx(i,jb ,k)-vflx(i,j,k))*delt1*scp2i(i)
      util2(i,j)=.5*(dpold(i,j,k)+dp(i,j,kn)-flxdiv)
      util1(i,j)=.5*(dpold(i,j,k)+dp(i,j,kn)+flxdiv)
      offset=min(0.,util1(i,j),util2(i,j))
      util2(i,j)=util2(i,j)-offset
      util1(i,j)=util1(i,j)-offset
c
      smin=min(smin,saln(i,j,kn))
      smax=max(smax,saln(i,j,kn))
 49   continue
c
      if (smin.lt.0.) then
      do 490 j=1,jj
      do 490 l=1,isp(j)
      do 490 i=ifp(j,l),ilp(j,l)
      if (saln(i,j,kn).eq.smin)
     . write (lp,'(i9,'' i,j,k='',3i4,'' neg. salin before advem call'',
     . 1pe9.1)') nstep,i,j,k,smin
 490  continue
      end if
c
      call advem(2,saln(1,1,kn),uflx(1,1,k),vflx(1,1,k),scp2,scp2i,
     .           delt1,util1,util2)
c
      do 46 j=1,jj
      do 46 l=1,isp(j)
      do 46 i=ifp(j,l),ilp(j,l)
c
c --- substitute depth-weighted averages for saln at massless grid points.
c --- (scan layers in top-down direction to save time.)
      q=onecm-min(onecm,dp(i,j,kn))
      saln(i,j,kn)=(saln(i,j,kn)*dp(i,j,kn)+saln(i,j,kn-1)*q)/
     .             (             dp(i,j,kn)+               q)
c
      sminn=min(sminn,saln(i,j,kn))
      smaxx=max(smaxx,saln(i,j,kn))
c
c --- time smoothing of thickness field
      pold=max(0.,dpold(i,j,k))
      pmid=max(0.,dp(i,j,km))
      pnew=max(0.,dp(i,j,kn))
      dp(i,j,km)=pmid*wts1+(pold+pnew)*wts2
c --- time smoothing of thermodynamic variable(s) (part 2)
      pmid=max(0.,dp(i,j,km))
 46   saln(i,j,km)=(saln(i,j,km)+wts2*saln(i,j,kn)*pnew)/(pmid+onemm)
c
      if (sminn.lt.0.) then
      do 492 j=1,jj
      do 492 l=1,isp(j)
      do 492 i=ifp(j,l),ilp(j,l)
      if (saln(i,j,kn).gt.sminn) go to 492
      write (lp,'(i9,'' i,j,k='',3i4,'' neg. salin after  advem call'',
     . 1pe9.1)') nstep,i,j,k,sminn
 492  continue
      end if
c
cdiag if (itest.gt.0.and.jtest.gt.0)
cdiag.write (lp,'(i9,3i4,'' t,s,dp after advection   '',2f9.3,f8.2)')
cdiag.nstep,itest,jtest,k,temp(itest,jtest,kn),saln(itest,jtest,kn),
cdiag.dp(itest,jtest,kn)/onem
c
      if (diagno)
     . write (lp,'(i9,i3,'' min/max of s after advection:'',4f7.2)')
     . nstep,k,sminn,smaxx
c
c --- ---------------------------------------------------------
c --- diffusion of thermodynamic variable(s) in interior layers
c --- ---------------------------------------------------------
c
      do 145 j=1,jj
      ja=mod(j-2+jj,jj)+1
c
      do 144 l=1,isu(j)
      do 144 i=ifu(j,l),ilu(j,l)
      factor=scu(i)*harmon(max(dp(i-1,j,kn),onemm)
     .                    ,max(dp(i  ,j,kn),onemm))
 144  uflux2(i,j)=factor*(saln(i-1,j,kn)-saln(i,j,kn))
c
      do 145 l=1,isv(j)
      do 145 i=ifv(j,l),ilv(j,l)
      factor=scv(i)*harmon(max(dp(i,ja ,kn),onemm)
     .                    ,max(dp(i,j  ,kn),onemm))
 145  vflux2(i,j)=factor*(saln(i,ja ,kn)-saln(i,j,kn))
c
      do 146 j=1,jj
      jb=mod(j     ,jj)+1
      do 146 l=1,isp(j)
      do 146 i=ifp(j,l),ilp(j,l)
      factor=temdff*delt1/(scp2(i)*max(dp(i,j,kn),onemm))
      saln(i,j,kn)=saln(i,j,kn)-(uflux2(i+1,j)-uflux2(i,j)
     .                          +vflux2(i,jb )-vflux2(i,j))*factor
 146  temp(i,j,kn)=tofsig(theta(k)+thbase,saln(i,j,kn))
c
cdiag if (itest.gt.0.and.jtest.gt.0)
cdiag.write (lp,'(i9,3i4,'' t,s,dp after isopyc.mix. '',2f9.3,f8.2)')
cdiag.nstep,itest,jtest,k,temp(itest,jtest,kn),saln(itest,jtest,kn),
cdiag.dp(itest,jtest,kn)/onem
c
c --- advection of 'ventilation' tracer (every 5 time steps only)
c
      if (trcout.and.mod(nstep,5).eq.0) then
      do 68 j=1,jj
      jb=mod(j     ,jj)+1
      do 68 l=1,isp(j)
      do 68 i=ifp(j,l),ilp(j,l)
      flxdiv=(uflx(i+1,j,k)-uflx(i,j,k)
     .       +vflx(i,jb ,k)-vflx(i,j,k))*5.*baclin*scp2i(i)
      util2(i,j)=.5*(dpold(i,j,k)+dp(i,j,kn)-flxdiv)
      util1(i,j)=.5*(dpold(i,j,k)+dp(i,j,kn)+flxdiv)
      offset=min(0.,util1(i,j),util2(i,j))
      util2(i,j)=util2(i,j)-offset
      util1(i,j)=util1(i,j)-offset
 68   tracer(i,j,k)=max(0.,tracer(i,j,k))
      call advem(2,tracer(1,1,k),uflx(1,1,k),vflx(1,1,k),scp2,scp2i,
     .           5.*baclin,util1,util2)
      end if
c
      end if                !  k < or = 1
c
 81   continue
c
      return
      end
